/*******************************************
 LAPG  ϱ 
 ø  Ʈ, Ʈݱ  Ѵ.  
*******************************************/
#include <termios.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>            // write(), read() ϴ   
#include <sys/signal.h>

/*UART*/
#define BAUDRATE_UART B115200	

#define _POSIX_SOURCE 1 /*POSIX compliant source*/
#define false 0
#define true 1

int fd_UART;
struct termios tio_UART;

void UART_Open(char *device_uart)
{
	/*Non-blocking  ø ġ .(readԼ ȣ  ﰢ )*/
	fd_UART = open(device_uart, O_RDWR | O_NOCTTY | O_NONBLOCK );//
	if(fd_UART < 0){perror(device_uart); exit(-1);}
	//	printf("success UART Open\n");
		
	/*canonical Է ó  Ʈ*/
	/*BAUDRATE_UART :  ӵ.*/
	/*CS8 : N81*/
	/*CLOCAL : Local connection.    ʴ´. */
//	tcgetattr(fd_UART, &tio_UART);
	tio_UART.c_cflag = BAUDRATE_UART | CS8 | CLOCAL;
	tio_UART.c_iflag = IGNPAR ; /*Parity ִ ڹƮ Ѵ.*/
	tio_UART.c_oflag = 0;
	tio_UART.c_lflag = 0;
	tio_UART.c_cc[VMIN] = 0;
	tio_UART.c_cc[VTIME] = 1;
	tcflush(fd_UART, TCIFLUSH);
	tcsetattr(fd_UART, TCSANOW, &tio_UART);
}

void UART_Close(void)
{
	close(fd_UART);
}

int main()
{
	
	
	unsigned char data_in = 0x03;
	unsigned char data_out = 0x02;
	unsigned char ack_data = 0xaa;
	unsigned char data = 0x00;
	unsigned char command = 0x01;
	unsigned char temp = 0x00;
	unsigned int count = 0;

	
	
	UART_Open("/dev/ttyS1");
	
		
	while(1)
	{
		if( read(fd_UART, &data, 1) < 0)
		{}
		else
		{
			printf("data= %.2x ",data);
			
			if(data==0xC0 && command == 0x01)
			{
				write(fd_UART,&data_in, 1);
				write(fd_UART,&data_out, 1);
			}
			if(data==0x61 && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
				count = (unsigned int)data_in;
				command = 0x00;
			}
			if(data==0x62 && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
				count = (unsigned int)data_in*4;
				command = 0x00;
			}
			if(data==0x64 && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
				count = (unsigned int)data_in*16;
				command = 0x00;
			}
			if(data==0x68 && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
				count = (unsigned int)data_in*64;
				command = 0x00;
			}
			if(data==0x98 && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
			}
			if(data==0x9C && command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
			}
			if(command == 0x01)
			{
				write(fd_UART,&ack_data, 1);
			}

			if((count % ((unsigned int)data_in))==0 && count !=0)
			{
				int i;
				for(i=0;i<(unsigned int)data_out;i++)
				{
					write(fd_UART,&temp, 1);
				}
			}
			
			if(count > 0) count--;
			else command = 0x01;
		}
	}
	UART_Close();
	
	return 0;
}
/*
// 忡 ͸ о´.
int UART_Read(void)
{
	unsigned char data = LAPG_ACK_ERROR;
	if( read(fd_UART, &data, 1) < 0)
		return false;
	else
	{
		if(data == LAPG_ACK_OK)
			return true;
		else
			return false;
	}
}


unsigned char UART_Read(void)
{
	 data=0;
	
	if( read(fd_UART, &data, 1) < 0)
		return -1;
	else
		return data;
}

unsigned char Busy_Check(void)
{
	unsigned char op = 0xb5;
	unsigned char busy = 10;
	
	write(fd_UART0, &op, 1);
	read(fd_UART0, &busy, 1);		
	
	return busy;
}

//  ӵ 
void Set_BothSpeed(unsigned short int left, unsigned short int right)
{
	unsigned char op = 0xa2;
	unsigned char param1 = (left >> 8);
	unsigned char param2 = (left & 0xff);
	unsigned char param3 = (right >> 8);
	unsigned char param4 = (right & 0xff);
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&param1, 1) ;
	write(fd_UART0,&param2, 1) ;
	write(fd_UART0,&param3, 1) ;
	write(fd_UART0,&param4, 1) ;		
}

//  ܼ  
void Set_BothStep(unsigned short int left, unsigned short int right)
{
	unsigned char op = 0xa5;
	unsigned char param1 = (left >> 8);
	unsigned char param2 = (left & 0xff);
	unsigned char param3 = (right >> 8);
	unsigned char param4 = (right & 0xff);
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&param1, 1) ;
	write(fd_UART0,&param2, 1) ;
	write(fd_UART0,&param3, 1) ;
	write(fd_UART0,&param4, 1) ;	
}

// ȸ 
void Set_Angle(unsigned short int angle)
{
	unsigned char op = 0xa6;
	unsigned char param1 = (angle >> 8);
	unsigned char param2 = (angle & 0xff);
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&param1, 1) ;
	write(fd_UART0,&param2, 1) ;
}

// Ÿ 
void Set_Distance(unsigned short int dis)
{
	unsigned char op = 0xa7;
	unsigned char param1 = (dis >> 8);
	unsigned char param2 = (dis & 0xff);
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&param1, 1) ;
	write(fd_UART0,&param2, 1) ;	
}

//  Ӱ 
void Set_BothAccel(unsigned char left, unsigned char right) 
{ 	
	unsigned char op = 0xaa ;
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&left, 1) ;
	write(fd_UART0,&right, 1) ;
}

//  Ӱ 
void Set_BothDecel(unsigned char left, unsigned char right) 
{ 	
	unsigned char op = 0xad ;
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&left, 1) ;
	write(fd_UART0,&right, 1) ;
}

//   Ӱ  
void Set_BothStop(unsigned char left, unsigned char right)
{
	unsigned char op = 0xb0;
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&left, 1) ;
	write(fd_UART0,&right, 1) ;
}

// sec*0.01   ︮ 
void Ring(unsigned char sec)
{
	unsigned char op = 0xb1;
	
	write(fd_UART0,&op, 1) ;
	write(fd_UART0,&sec, 1) ;	
}

void Ring_Off(void)
{
	unsigned char op = 0x87;
	
	write(fd_UART0,&op, 1) ;		
}

//  (step) 
void Go_StepForward(void)
{
	unsigned char op = 0xc0;
	
	write(fd_UART0, &op, 1) ;
}

//  (step) 
void Go_StepBack(void)
{
	unsigned char op = 0xc1;
	
	write(fd_UART0, &op, 1) ;	
}

// · ڸ ȸ(step)
void Rotate_StepLeft(void)
{
	unsigned char op = 0xc2;
	
	write(fd_UART0, &op, 1) ;	
}

//  ڸ ȸ(step)
void Rotate_StepRight(void)
{
	unsigned char op = 0xc3;
	
	write(fd_UART0, &op, 1) ;	
}

// ȸ(ʹ )(step)
void Turn_StepLeft(void)
{
	unsigned char op = 0xc4;
	
	write(fd_UART0, &op, 1) ;	
}

// ȸ(ʹ )(step)
void Go_StepRight(void)
{
	unsigned char op = 0xc5;
	
	write(fd_UART0, &op, 1) ;	
}

// · ڸ ȸ(angle)
void Rotate_AngleLeft(void)
{
	unsigned char op = 0xc6;
	
	write(fd_UART0, &op, 1) ;	
}

//  ڸ ȸ(angle)
void Rotate_AngleRight(void)
{
	unsigned char op = 0xc7;
	
	write(fd_UART0, &op, 1) ;	
}

//  (distance) 
void Go_DisForward(void)
{
	unsigned char op = 0xc8;
	
	write(fd_UART0, &op, 1) ;
}

//  (distance) 
void Go_DisBack(void)
{
	unsigned char op = 0xc9;
	
	write(fd_UART0, &op, 1) ;	
}

// (ӿ)
void Stop(void)
{
	unsigned char op = 0xca;
	
	write(fd_UART0, &op, 1) ;		
}

unsigned int Get_Distance_Right(void) 
{ 
	unsigned char op = 0xcf; 
	unsigned char param1 ; 
	unsigned char param2 ; 
	unsigned char param3 ; 
	unsigned char param4 ; 
	unsigned int distance ; 
		 
	write(fd_UART0,&op, 1) ; 
	
	while(1)
	{
		read(fd_UART0,&param1, 1) ;
		if(param1 != 255)
			break;
	}
//	read(fd_UART0,&param1, 1) ; 
	read(fd_UART0,&param2, 1) ; 
	read(fd_UART0,&param3, 1) ; 
	read(fd_UART0,&param4, 1) ; 
	distance = (param3 << 8) + (param4) ;	 
	
	printf("param1 : %3d, param2 : %3d, param3 : %3d, param4 : %3d, distance : %4d\n", param1, param2, param3, param4, distance);
	if(distance < 0)
		distance = 0;	 
	
	return distance ; 
}	

void Cancel_Holding(void)
{
	unsigned char op = 0xe1;
	
	write(fd_UART0, &op, 1) ;			
}

 
 
 
void reset_distance_both() {
	unsigned char op = 0xD3 ;	
	
	write(fd_UART0,&op, 1) ;		
}
*/

/*
int echo(int a)
{
	int temp ;
	write(fd_UART0, &a, 1) ;

	
	read(fd_UART0,&temp,1);
	
	return temp;
}
*/
