#include <stdio.h>


//    
#define LAPG_RESET_CONFIGRATION      0
#define LAPG_RESET_DCLK      1
#define LAPG_RESET_EDGE      2
#define LAPG_RESET_EXE_MODE      3
#define LAPG_RESET_PROPAGATION_DELAY      4
#define LAPG_RESET_RESET      5

//    
#define LAPG_EXECUTE_INJECTION      0
#define LAPG_EXECUTE_SAMPLING      1
#define LAPG_EXECUTE_CNT_BASE      2
#define LAPG_EXECUTE_COUNT      3
#define LAPG_EXECUTE_RESET      5

// Ʈ  Լ
#define BITSPERBYTE     8
#define NBYTES(nbits)   (((nbits) + BITSPERBYTE - 1) / BITSPERBYTE)
#define BIT2BYTE(ibit)  ((ibit) / BITSPERBYTE)
#define BIT2SHIFT(ibit) ((ibit) % BITSPERBYTE)
#define BIT2MASK(ibit)  (1 << BIT2SHIFT(ibit))
#define BYTE2BIT(ibyte) ((ibyte) * BITSPERBYTE)

//  ʵ 
struct _data_field							// LAPG   ڷᱸ
{
	unsigned int width_size;							//  ο 
	unsigned int height_size;							//  ο 
	unsigned char* data;
};

//  ʱⰪ
//	unsigned int timestamp;								//  ð 
unsigned char reset_command = 0x80;
unsigned char exe_command = 0x61;
struct _data_field data_field;


/////////////////////////////////////////////////////////////////////////////
////////////////////////////////Ʈ  Լ //////////////////////////////
/////////////////////////////////////////////////////////////////////////////

__inline__ void bit_set( unsigned char *flags, int bit )
{
   *flags |= (1U << bit);
}

__inline__ void bit_clr( unsigned char *flags, int bit )
{
   *flags &= ~(1U << bit);
}

__inline__ unsigned char bit_return_value( unsigned char *flags, unsigned char bit_size, int bit)
{
	return ((*flags >> bit) & bit_size);
}

__inline__ void bit_set_value( unsigned char *flags, unsigned char *value , unsigned char bit_size, int bit)
{
	*flags &= ~(bit_size << bit);		//ϴ Ʈ .(  )
	*value &= bit_size;		//  ȿ . 0,1 ǹǷ.
	*flags |= (*value << bit);		// value 
}

/////////////////////////////////////////////////////////////////////////////
////////////////////////// reset command mode setting ///////////////////////
/////////////////////////////////////////////////////////////////////////////

// ¸  Ʈ Ѵ.
// mode : ٲ  (define ) , value :  ( 庰 ũ⿡ ° )
void set_reset_command(int mode, unsigned char value)
{
	switch(mode)
	{
		case LAPG_RESET_CONFIGRATION :
			bit_set_value(&reset_command, &value, 0x01, 6);		//7° Ʈ 
			break;
		case LAPG_RESET_DCLK :
			bit_set_value(&reset_command, &value, 0x03, 4);		//6, 5° Ʈ 			
			break;
		case LAPG_RESET_EDGE :
			bit_set_value(&reset_command, &value, 0x01, 3);		//4° Ʈ 
			break;
		case LAPG_RESET_EXE_MODE :
			bit_set_value(&reset_command, &value, 0x01, 2);		//3° Ʈ 
			break;
		case LAPG_RESET_PROPAGATION_DELAY :
			bit_set_value(&reset_command, &value, 0x03, 0);		//2, 1° Ʈ 
			break;
		default:
			reset_command = 0x80;
			break;
	}
}

// ¸  Ʈ Ѵ.
// mode :  (define )
unsigned char read_reset_command(int mode)
{
	switch(mode)
	{
		case LAPG_RESET_CONFIGRATION :
			return bit_return_value(&reset_command, 0x01, 6);
			break;
		case LAPG_RESET_DCLK :
			return bit_return_value(&reset_command, 0x03, 4);
			break;
		case LAPG_RESET_EDGE :
			return bit_return_value(&reset_command, 0x01, 3);
			break;
		case LAPG_RESET_EXE_MODE :
			return bit_return_value(&reset_command, 0x01, 2);
			break;
		case LAPG_RESET_PROPAGATION_DELAY :
			return bit_return_value(&reset_command, 0x03, 0);
			break;
		default:
			return 0;
			break;
	}
}

/////////////////////////////////////////////////////////////////////////////
////////////////////////// execute command mode setting /////////////////////
/////////////////////////////////////////////////////////////////////////////

//   Ʈ Ѵ.
// mode : ٲ  (define ) , value :  ( 庰 ũ⿡ ° )
void set_exe_command(int mode, unsigned char value)
{
	switch(mode)
	{
		case LAPG_EXECUTE_INJECTION :
			bit_set_value(&exe_command, &value, 0x01, 6);		//7° Ʈ 
			break;
		case LAPG_EXECUTE_SAMPLING :
			bit_set_value(&exe_command, &value, 0x01, 5);		//6° Ʈ 			
			break;
		case LAPG_EXECUTE_CNT_BASE :
			bit_set_value(&exe_command, &value, 0x01, 4);		//5° Ʈ 
			break;
		case LAPG_EXECUTE_COUNT :
			bit_set_value(&exe_command, &value, 0x0f, 0);		//4,3,2,1° Ʈ 
			break;
		default:
			exe_command = 0x61;
			break;
	}
}

//   Ʈ Ѵ.
// mode :  (define )
unsigned char read_exe_command(int mode)
{
	switch(mode)
	{
		case LAPG_EXECUTE_INJECTION :
			return bit_return_value(&exe_command, 0x01, 6);
			break;
		case LAPG_EXECUTE_SAMPLING :
			return bit_return_value(&exe_command, 0x01, 5);
			break;
		case LAPG_EXECUTE_CNT_BASE :
			return bit_return_value(&exe_command, 0x01, 4);
			break;
		case LAPG_EXECUTE_COUNT :
			return bit_return_value(&exe_command, 0x0f, 0);
			break;
		default:
			return 0;
			break;
	}
}

/////////////////////////////////////////////////////////////////////////////
//////////////////////////data field's data setting /////////////////////////
/////////////////////////////////////////////////////////////////////////////

void init_data_field(unsigned int height, unsigned int width)
{
	data_field.width_size=width;
	data_field.height_size=height;
	data_field.data=(unsigned char*)malloc((NBYTES(data_field.height)*data_field.width)*sizeof(unsigned char));
}

void uninit_data_field()
{
	free(data_field.data);
	data_field.width_size=0;
	data_field.height_size=0;
}
void set_data_field(unsigned int y_point, unsigned int x_point, unsigned char value)
{
	bit_set_value((data_field.data+NBYTES(data_field.height)*(x_point-1)+BIT2BYTE(y_point-1)),&value, 0x01, BIT2SHIFT(y_point-1));
}

unsigned char read_data_field(unsigned int y_point, unsigned int x_point)
{
	return bit_return_value((data_field.data+NBYTES(data_field.height)*(x_point-1)+BIT2BYTE(y_point-1)), 0x01, BIT2SHIFT(y_point-1));
}


int main()
{
	int i;
	for(i=0;i<20;i++)
	{
		printf ("%d %d\n",i,NBYTES(i));
	}
	printf ("reset_command: %x  init\n", reset_command);
	set_reset_command(LAPG_RESET_EDGE, 1);
	printf ("reset_command: %x  edge set \n", reset_command);
	printf ("edge: %x\n", read_reset_command(LAPG_RESET_EDGE));
	set_reset_command(LAPG_RESET_DCLK, 3);
	printf ("reset_command: %x  dclk 3 \n", reset_command);
	set_reset_command(99, 3);
	printf ("reset_command: %x\n command reset", reset_command);

	return 0;
}
