-- hopesjs computer adder logic
library ieee;
use ieee.std_logic_1164.all;

entity fadder16 is
generic (size: integer := 16);
port(
	x,y: in std_logic_vector(size-1 downto 0);
	s: out std_logic_vector(size-1 downto 0);
	cout: out std_logic
);
end fadder16;

architecture FADD_16 of fadder16 is
	component hadder port(
		x,y: in std_logic;
		s,c: out std_logic);
	end component;

	component fadder1 port(
		x,y,z: in std_logic;
		s,c: out std_logic);
	end component;

signal coutSUM: std_logic_vector(size-2 downto 0);
begin
	a0: hadder port map (x(0), y(0), s(0), coutSUM(0));
	add_loop: for i in 1 to size-2 generate
		ai: fadder1 port map (x(i), y(i), coutSUM(i-1),  s(i),  coutSUM(i));
	end generate add_loop;
	alast: fadder1 port map (x(size-1), y(size-1), coutSUM(size-2), s(size-1), cout);
end FADD_16;
