## Copyright (C) 1991-2004 Altera Corporation
## Any  megafunction  design,  and related netlist (encrypted  or  decrypted),
## support information,  device programming or simulation file,  and any other
## associated  documentation or information  provided by  Altera  or a partner
## under  Altera's   Megafunction   Partnership   Program  may  be  used  only
## to program  PLD  devices (but not masked  PLD  devices) from  Altera.   Any
## other  use  of such  megafunction  design,  netlist,  support  information,
## device programming or simulation file,  or any other  related documentation
## or information  is prohibited  for  any  other purpose,  including, but not
## limited to  modification,  reverse engineering,  de-compiling, or use  with
## any other  silicon devices,  unless such use is  explicitly  licensed under
## a separate agreement with  Altera  or a megafunction partner.  Title to the
## intellectual property,  including patents,  copyrights,  trademarks,  trade
## secrets,  or maskworks,  embodied in any such megafunction design, netlist,
## support  information,  device programming or simulation file,  or any other
## related documentation or information provided by  Altera  or a megafunction
## partner, remains with Altera, the megafunction partner, or their respective
## licensors. No other licenses, including any licenses needed under any third
## party's intellectual property, are provided herein.

## VENDOR "Altera"
## PROGRAM "Quartus II"
## VERSION "Version 4.1 Build 181 06/29/2004 SJ Full Version"

## DATE "07/04/2007 19:46:25"

## 
## Device: Altera EP1K100QC208-3 Package PQFP208
## 

## 
## This Tcl script should be used for PrimeTime (VHDL output from Quartus II) only
## 

## This file can be sourced in primetime

set report_default_significant_digits 3
set hierarchy_separator .

set quartus_root "c:/altera/quartus41/"
set search_path [list . [format "%s%s" $quartus_root "eda/synopsys/primetime/lib"]  ]

set link_path [list *  flex10ke_asynch_io_lib.db  flex10ke_lcell_register_lib.db  flex10ke_asynch_lcell_lib.db  flex10ke_asynch_mem_lib.db  flex10ke_pll_lib.db  alt_vtl.db]

read_vhdl  -vhdl_compiler  flex10ke_all_pt.vhd 

##########################
## DESIGN ENTRY SECTION ##
##########################

read_vhdl  -vhdl_compiler watch.vho
current_design watch
link
read_sdf watch_vhd.sdo

################################
## TIMING CONSTRAINTS SECTION ##
################################

## project wide definition ##
# WARNING : The required clock period is not set.The default value (100 ns) is used.
create_clock -period 100.000 -waveform {0.000 50.000} [get_ports CLK ] -name CLK
# WARNING : The required clock period is not set.The default value (100 ns) is used.
create_clock -period 100.000 -waveform {0.000 50.000} [get_ports RxD ] -name RxD

set_propagated_clock [all_clocks]

foreach_in_collection clk_item [all_clocks] {
	set_false_path -from [get_clocks $clk_item] -to [remove_from_collection [all_clocks] [get_clocks $clk_item]]
}

## Create Collections ##

## Individual pin definition ##

# Max output delay for clock-to-output.
# WARNING : The required clock-to-output time from CLK to TxD is not set. The default value (0.00) is used.
set_output_delay -max -add_delay 0.00 -clock [get_clocks CLK ] [get_ports TxD ]

# Min output delay for clock-to-output.
# WARNING : The required clock-to-output min delay from CLK to TxD is not set. The default value (0.00) is used.
set_output_delay -min -add_delay 0.00 -clock [get_clocks CLK ] [get_ports TxD ]

## Output pin capacitance ##
# Warning: using default load capacitance for LVTTL/LVCMOS output port
set_load 30 [get_ports { TxD count_out[7] count_out[6] count_out[5] count_out[4] count_out[3] count_out[2] count_out[1] count_out[0] decode_out[7] decode_out[6] decode_out[5] \
    decode_out[4] decode_out[3] decode_out[2] decode_out[1] decode_out[0] } ]

## Others definition ##

## Collection definition ##

set dst_port_grp0 [get_ports {count_out[6] count_out[5] count_out[4] count_out[3] count_out[2] count_out[1] count_out[0]}]
# WARNING : The required clock-to-output min delay from CLK to $dst_port_grp0 is not set. The default value (0.00) is used. 
set_output_delay -min -add_delay 0.00 -clock [get_clocks CLK ] $dst_port_grp0

set dst_port_grp1 [get_ports {count_out[6] count_out[5] count_out[4] count_out[3] count_out[2] count_out[1] count_out[0]}]
# WARNING : The required clock-to-output time from CLK to $dst_port_grp1 is not set. The default value (0.00) is used. 
set_output_delay -max -add_delay 0.00 -clock [get_clocks CLK ] $dst_port_grp1

set dst_port_grp2 [get_ports {decode_out[7] decode_out[6] decode_out[5] decode_out[4] decode_out[3] decode_out[2] decode_out[1] decode_out[0]}]
# WARNING : The required clock-to-output min delay from CLK to $dst_port_grp2 is not set. The default value (0.00) is used. 
set_output_delay -min -add_delay 0.00 -clock [get_clocks CLK ] $dst_port_grp2

set dst_port_grp3 [get_ports {decode_out[7] decode_out[6] decode_out[5] decode_out[4] decode_out[3] decode_out[2] decode_out[1] decode_out[0]}]
# WARNING : The required clock-to-output time from CLK to $dst_port_grp3 is not set. The default value (0.00) is used. 
set_output_delay -max -add_delay 0.00 -clock [get_clocks CLK ] $dst_port_grp3


## Destroy Collections ##

update_timing
