library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_logic_unsigned.ALL;
use IEEE.std_logic_arith.ALL;


entity watch is
	port(
		CLK : in std_logic;
	  RESET : in std_logic;
		RxD : in std_logic;
		TxD : out std_logic;
  count_out	: out std_logic_vector(7 downto 0);
 decode_out	: out std_logic_vector(7 downto 0)
		
	);
	
end watch;

architecture Behavioral of watch is

component LAPG is
	generic(INPUT_BYTE : integer:=1; OUTPUT_BYTE : integer:=3; OSC : integer:=5);
	port (
		CLK : in std_logic;
		RESET : in std_logic;
		RxD : in std_logic;
		Sampled_Data : in std_logic_vector((OUTPUT_BYTE * 8) - 1 downto 0);
		TxD : out std_logic;
		DCLK : out std_logic;
		Injection_Data	: out std_logic_vector((INPUT_BYTE * 8) - 1 downto 0)
		);
end component;


component segment_driver is
		port(
		 clk		: in std_logic;
		 start_stop : in std_logic;
		 clear		: in std_logic;
		 count_dec	: out std_logic_vector(7 downto 0);
		 sel_decode	: out std_logic_vector(7 downto 0);
		 astartstop  : out std_logic
		);
end component;

 	signal input				: std_logic_vector(7 downto 0); -- := "0000000000000000000000000000000000000000000000000000000000000000";
	signal probe				: std_logic_vector(23 downto 0); 
	signal DCLK					: std_logic; -- := '0';
begin

U1: LAPG
port map (
	CLK => CLK,			
	RESET	=> RESET,						
	RxD => RxD,		
	TxD => TxD,	
	DCLK => DCLK,			
	Sampled_Data => probe,
	Injection_Data => input
);

U2: segment_driver
port map (
	clk => DCLK	, 
	start_stop => input(0),
	clear => input(1),
	count_dec => probe(7 downto 0),	
	sel_decode => probe(15 downto 8),
	astartstop => probe(16)
);	
     count_out <=probe(7 downto 0);	
	 decode_out <=probe(15 downto 8);
end Behavioral;